package main

import (
	"fmt"
	"math"
)

// 返回计算结果和错误信息
func sqrt(x float64) (float64, error) {
	if x < 0 {
		return 0, fmt.Errorf("不能对负数 %f 开平方", x)
	}
	return math.Sqrt(x), nil
}

// 命名返回值
func split(sum int) (x, y int) {
	x = sum * 4 / 9
	y = sum - x
	return // 裸返回
}

func main() {
	// 处理多返回值
	if result, err := sqrt(16); err != nil {
		fmt.Println("错误:", err)
	} else {
		fmt.Println("平方根:", result)
	}

	// 处理错误情况
	if _, err := sqrt(-4); err != nil {
		fmt.Println("错误:", err)
	}

	// 使用命名返回值
	a, b := split(17)
	fmt.Printf("split(17) = %d, %d\n", a, b)
}
